<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>NANO102/112 BSP: StdDriver/src/scuart.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../M0Banner_v2.jpg"/></td>
  <td id="projectalign">
   <div id="projectname">NANO102/112 BSP<span id="projectnumber">&#160;V3.04.000</span>
   </div>
   <div id="projectbrief">The Board Support Package for Nano102/112 Series</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',false,false,'search.php','Search');
});
/* @license-end */
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_0d398eaf8b2db165a9197a6619ec9f0e.html">StdDriver</a></li><li class="navelem"><a class="el" href="../../dir_3abedc03644d33bc69016fb8a5546004.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">scuart.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../df/d4a/scuart_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**************************************************************************/</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="preprocessor">#include &quot;<a class="code" href="../../da/d91/_nano1_x2_series_8h.html">Nano1X2Series.h</a>&quot;</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span> </div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno"><a class="line" href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaee19cdbe4e45656a56c250577c1594c7">   32</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaee19cdbe4e45656a56c250577c1594c7">SCUART_Close</a>(<a class="code hl_struct" href="../../d6/d6b/struct_s_c___t.html">SC_T</a>* sc)</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>{</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>    sc-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gae664041daf8c26402757b67aaa5677e2">IER</a> = 0;</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    sc-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga35c7fa9d62529991f3e3b737945db3a4">UACTL</a> = 0;</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>    sc-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga657b6619f178ac1a923485d599c1b0f7">CTL</a> = 0;</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span> </div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>}</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span> </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span> </div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span><span class="keyword">static</span> uint32_t SCUART_GetClock(<a class="code hl_struct" href="../../d6/d6b/struct_s_c___t.html">SC_T</a> *sc)</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>{</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>    uint32_t u32ClkSrc = (<a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKSEL2 &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga186d7a361e53779d91d1a55cafab3971">CLK_CLKSEL2_SC_S_Msk</a>) &gt;&gt; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga8c03272005bbf1096703e78d7724d256">CLK_CLKSEL2_SC_S_Pos</a>;</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>    uint32_t u32Clk;</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span> </div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>    <span class="comment">// Get smartcard module clock</span></div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>    <span class="keywordflow">if</span>(u32ClkSrc == 0)</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>        u32Clk = <a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#a37c1644396b5996e92902bbf2dfc3ec5">__HXT</a>;</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>    <span class="keywordflow">else</span> <span class="keywordflow">if</span>(u32ClkSrc == 1)</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>        u32Clk = <a class="code hl_function" href="../../d5/d72/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaf42f850d36900fcf77e4643f2db5470b">CLK_GetPLLClockFreq</a>();</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>    <span class="keywordflow">else</span> <span class="keywordflow">if</span>(u32ClkSrc == 2)</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>    {</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>        <span class="keywordflow">if</span>((<a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#gae3d9f52a1a315303ad04f0576bd42a25">SYS</a>-&gt;IRCTRIMCTL &amp; <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a90f0ecca15012a971a45550042d79e22">SYS_IRCTRIMCTL_TRIM_SEL_Msk</a>) == <a class="code hl_define" href="../../dc/d4e/group___n_a_n_o1_x2___s_y_s___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gab6f82bf5cf18e6161e3d937d3363d76f">SYS_IRCTRIMCTL_TRIM_16M</a>)</div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>            u32Clk = <a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#aae5c5ec4722a291e1271743d45414223">__HIRC16M</a>;</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>            u32Clk = <a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#ad145c32431f633b887d84ef0c78f42f3">__HIRC12M</a>;</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>    }</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>        u32Clk = <a class="code hl_function" href="../../d5/d72/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga27ded0f4435751be979927718884488f">CLK_GetHCLKFreq</a>();</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span> </div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>    <span class="keywordflow">if</span>(sc == <a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#gadab49b9fc27febd87bbc529b0b9a5d67">SC0</a>)</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>        u32Clk /= ((<a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKDIV0 &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga4a516bd550d590ea173cce02dad4ef5c">CLK_CLKDIV0_SC0_N_Msk</a>) &gt;&gt; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga3b6f575ecbb77b8133370700fd794a9e">CLK_CLKDIV0_SC0_N_Pos</a>) + 1;</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>        u32Clk /= (<a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKDIV1 &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gaafab8162025518e09322a6a7a47210e8">CLK_CLKDIV1_SC1_N_Msk</a>) + 1;</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span> </div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>    <span class="keywordflow">return</span> u32Clk;</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>}</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span> </div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span> </div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span> </div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno"><a class="line" href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gac5ef61f705cf44b678207aaecb2d8b35">   91</a></span>uint32_t <a class="code hl_function" href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gac5ef61f705cf44b678207aaecb2d8b35">SCUART_Open</a>(<a class="code hl_struct" href="../../d6/d6b/struct_s_c___t.html">SC_T</a>* sc, uint32_t u32baudrate)</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>{</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>    uint32_t u32Clk = SCUART_GetClock(sc), u32Div;</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span> </div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>    <span class="comment">// Calculate divider for target baudrate</span></div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>    u32Div = (u32Clk + (u32baudrate &gt;&gt; 1) - 1) / u32baudrate - 1;</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span> </div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>    sc-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga657b6619f178ac1a923485d599c1b0f7">CTL</a> = <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a3978657fb9b17744f11542cb5fe7bf8d">SC_CTL_SC_CEN_Msk</a> | <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a06ffeb93634ff42d4af4db99ffb7003e">SC_CTL_SLEN_Msk</a>;  <span class="comment">// Enable smartcard interface and stop bit = 1</span></div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>    sc-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga35c7fa9d62529991f3e3b737945db3a4">UACTL</a> = <a class="code hl_define" href="../../da/d40/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga44414b8c1a7255a01135a0e19d4509cc">SCUART_CHAR_LEN_8</a> | <a class="code hl_define" href="../../da/d40/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga4ba056464dc172c46a8c0def775d099c">SCUART_PARITY_NONE</a> | <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a0e5f441a813233c037fba14e3dee50bb">SC_UACTL_UA_MODE_EN_Msk</a>; <span class="comment">// Enable UART mode, disable parity and 8 bit per character</span></div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>    sc-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga45c091e2ae29b2e35d20f989adc427a2">ETUCR</a> = u32Div;</div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span> </div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>    <span class="keywordflow">return</span>(u32Clk / (u32Div + 1));</div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>}</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span> </div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno"><a class="line" href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga1b2ed639a9d9b3389a0252a3e0185ace">  113</a></span>uint32_t <a class="code hl_function" href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga1b2ed639a9d9b3389a0252a3e0185ace">SCUART_Read</a>(<a class="code hl_struct" href="../../d6/d6b/struct_s_c___t.html">SC_T</a>* sc, uint8_t *pu8RxBuf, uint32_t u32ReadBytes)</div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>{</div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>    uint32_t u32Count;</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span> </div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>    <span class="keywordflow">for</span>(u32Count = 0; u32Count &lt; u32ReadBytes; u32Count++)</div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>    {</div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>        <span class="keywordflow">if</span>(<a class="code hl_define" href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga1ca8f849e3eaeb01f952b6cb1dbe1541">SCUART_GET_RX_EMPTY</a>(sc))   <span class="comment">// no data available</span></div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>        {</div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>        }</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>        pu8RxBuf[u32Count] = <a class="code hl_define" href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga88bae72589f1b3169b6f44141624547a">SCUART_READ</a>(sc);    <span class="comment">// get data from FIFO</span></div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>    }</div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span> </div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>    <span class="keywordflow">return</span> u32Count;</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>}</div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span> </div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno"><a class="line" href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga99195e1a1d2f0b780a9ec769c5a6825a">  153</a></span>uint32_t <a class="code hl_function" href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga99195e1a1d2f0b780a9ec769c5a6825a">SCUART_SetLineConfig</a>(<a class="code hl_struct" href="../../d6/d6b/struct_s_c___t.html">SC_T</a>* sc, uint32_t u32Baudrate, uint32_t u32DataWidth, uint32_t u32Parity, uint32_t  u32StopBits)</div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>{</div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>    uint32_t u32Clk = SCUART_GetClock(sc), u32Div;</div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span> </div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>    <span class="keywordflow">if</span>(u32Baudrate == 0)    <span class="comment">// keep original baudrate setting</span></div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>    {</div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>        u32Div = sc-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga45c091e2ae29b2e35d20f989adc427a2">ETUCR</a> &amp; <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#adee0b60dba160108f8a33e8766148b1d">SC_ETUCR_ETU_RDIV_Msk</a>;</div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>    }</div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>    {</div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>        <span class="comment">// Calculate divider for target baudrate</span></div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>        u32Div = (u32Clk + (u32Baudrate &gt;&gt; 1) - 1)/ u32Baudrate - 1;</div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>        sc-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga45c091e2ae29b2e35d20f989adc427a2">ETUCR</a> = u32Div;</div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>    }</div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span> </div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>    sc-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga657b6619f178ac1a923485d599c1b0f7">CTL</a> = u32StopBits | <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a3978657fb9b17744f11542cb5fe7bf8d">SC_CTL_SC_CEN_Msk</a>;  <span class="comment">// Set stop bit</span></div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>    sc-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga35c7fa9d62529991f3e3b737945db3a4">UACTL</a> = u32Parity | u32DataWidth | <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a0e5f441a813233c037fba14e3dee50bb">SC_UACTL_UA_MODE_EN_Msk</a>;  <span class="comment">// Set character width and parity</span></div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span> </div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>    <span class="keywordflow">return</span>(u32Clk / (u32Div + 1));</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>}</div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span> </div>
<div class="line"><a id="l00184" name="l00184"></a><span class="lineno"><a class="line" href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga0023f5e961b902ed650fec7051b09f2b">  184</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga0023f5e961b902ed650fec7051b09f2b">SCUART_SetTimeoutCnt</a>(<a class="code hl_struct" href="../../d6/d6b/struct_s_c___t.html">SC_T</a>* sc, uint32_t u32TOC)</div>
<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span>{</div>
<div class="line"><a id="l00186" name="l00186"></a><span class="lineno">  186</span>    sc-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga90acfb650851f2b72a3dca73041b5df4">RFTMR</a> = u32TOC;</div>
<div class="line"><a id="l00187" name="l00187"></a><span class="lineno">  187</span>}</div>
<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span> </div>
<div class="line"><a id="l00189" name="l00189"></a><span class="lineno">  189</span> </div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno"><a class="line" href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga275c62ae8ce1ccbd4be6dd52a7ee6144">  198</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga275c62ae8ce1ccbd4be6dd52a7ee6144">SCUART_Write</a>(<a class="code hl_struct" href="../../d6/d6b/struct_s_c___t.html">SC_T</a>* sc,uint8_t *pu8TxBuf, uint32_t u32WriteBytes)</div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span>{</div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span>    uint32_t u32Count;</div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span>    int32_t i32TimeoutCnt = <a class="code hl_variable" href="../../d9/dd8/system___nano1_x2_series_8h.html#aa3cd3e43291e81e795d642b79b6088e6">SystemCoreClock</a>/10;</div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span> </div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span>    <span class="keywordflow">for</span>(u32Count = 0; u32Count != u32WriteBytes; u32Count++)</div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span>    {</div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span>        <span class="keywordflow">while</span>(<a class="code hl_define" href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga156dbf7f35a69e25f2115822fccfa717">SCUART_GET_TX_FULL</a>(sc)) { <span class="comment">// Wait &#39;til FIFO not full</span></div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>            <span class="keywordflow">if</span>(i32TimeoutCnt-- &lt;= 0)</div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>                <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span>        }</div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>        sc-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gadfe33df8456b56de687076679cd493f3">THR</a> = pu8TxBuf[u32Count];    <span class="comment">// Write 1 byte to FIFO</span></div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span>    }</div>
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>}</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span> </div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span> <span class="comment">/* end of group NANO1X2_SCUART_EXPORTED_FUNCTIONS */</span></div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span> <span class="comment">/* end of group NANO1X2_SCUART_Driver */</span></div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span> <span class="comment">/* end of group NANO1X2_Device_Driver */</span></div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span> </div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span><span class="comment">/*** (C) COPYRIGHT 2014 Nuvoton Technology Corp. ***/</span></div>
<div class="ttc" id="a_nano1_x2_series_8h_html"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html">Nano1X2Series.h</a></div><div class="ttdoc">Nano102/112 peripheral access layer header file. This file contains all the peripheral register's def...</div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_a06ffeb93634ff42d4af4db99ffb7003e"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#a06ffeb93634ff42d4af4db99ffb7003e">SC_CTL_SLEN_Msk</a></div><div class="ttdeci">#define SC_CTL_SLEN_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l08190">Nano1X2Series.h:8190</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_a0e5f441a813233c037fba14e3dee50bb"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#a0e5f441a813233c037fba14e3dee50bb">SC_UACTL_UA_MODE_EN_Msk</a></div><div class="ttdeci">#define SC_UACTL_UA_MODE_EN_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l08430">Nano1X2Series.h:8430</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_a3978657fb9b17744f11542cb5fe7bf8d"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#a3978657fb9b17744f11542cb5fe7bf8d">SC_CTL_SC_CEN_Msk</a></div><div class="ttdeci">#define SC_CTL_SC_CEN_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l08166">Nano1X2Series.h:8166</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_a90f0ecca15012a971a45550042d79e22"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#a90f0ecca15012a971a45550042d79e22">SYS_IRCTRIMCTL_TRIM_SEL_Msk</a></div><div class="ttdeci">#define SYS_IRCTRIMCTL_TRIM_SEL_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l04035">Nano1X2Series.h:4035</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_adee0b60dba160108f8a33e8766148b1d"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#adee0b60dba160108f8a33e8766148b1d">SC_ETUCR_ETU_RDIV_Msk</a></div><div class="ttdeci">#define SC_ETUCR_ETU_RDIV_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l08253">Nano1X2Series.h:8253</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga27ded0f4435751be979927718884488f"><div class="ttname"><a href="../../d5/d72/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga27ded0f4435751be979927718884488f">CLK_GetHCLKFreq</a></div><div class="ttdeci">uint32_t CLK_GetHCLKFreq(void)</div><div class="ttdoc">This function get HCLK frequency. The frequency unit is Hz.</div><div class="ttdef"><b>Definition:</b> <a href="../../de/da0/clk_8c_source.html#l00192">clk.c:192</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gaf42f850d36900fcf77e4643f2db5470b"><div class="ttname"><a href="../../d5/d72/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaf42f850d36900fcf77e4643f2db5470b">CLK_GetPLLClockFreq</a></div><div class="ttdeci">uint32_t CLK_GetPLLClockFreq(void)</div><div class="ttdoc">This function get PLL frequency. The frequency unit is Hz.</div><div class="ttdef"><b>Definition:</b> <a href="../../de/da0/clk_8c_source.html#l00228">clk.c:228</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga186d7a361e53779d91d1a55cafab3971"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga186d7a361e53779d91d1a55cafab3971">CLK_CLKSEL2_SC_S_Msk</a></div><div class="ttdeci">#define CLK_CLKSEL2_SC_S_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01607">Nano1X2Series.h:1607</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga3b6f575ecbb77b8133370700fd794a9e"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga3b6f575ecbb77b8133370700fd794a9e">CLK_CLKDIV0_SC0_N_Pos</a></div><div class="ttdeci">#define CLK_CLKDIV0_SC0_N_Pos</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01624">Nano1X2Series.h:1624</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga4a516bd550d590ea173cce02dad4ef5c"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga4a516bd550d590ea173cce02dad4ef5c">CLK_CLKDIV0_SC0_N_Msk</a></div><div class="ttdeci">#define CLK_CLKDIV0_SC0_N_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01625">Nano1X2Series.h:1625</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga8c03272005bbf1096703e78d7724d256"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga8c03272005bbf1096703e78d7724d256">CLK_CLKSEL2_SC_S_Pos</a></div><div class="ttdeci">#define CLK_CLKSEL2_SC_S_Pos</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01606">Nano1X2Series.h:1606</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_gaafab8162025518e09322a6a7a47210e8"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gaafab8162025518e09322a6a7a47210e8">CLK_CLKDIV1_SC1_N_Msk</a></div><div class="ttdeci">#define CLK_CLKDIV1_SC1_N_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01628">Nano1X2Series.h:1628</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n_html_ga4b355291fe6b8ba8e167ab0faa862e45"><div class="ttname"><a href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a></div><div class="ttdeci">#define CLK</div><div class="ttdoc">Pointer to CLK register structure.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l10651">Nano1X2Series.h:10651</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n_html_gadab49b9fc27febd87bbc529b0b9a5d67"><div class="ttname"><a href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#gadab49b9fc27febd87bbc529b0b9a5d67">SC0</a></div><div class="ttdeci">#define SC0</div><div class="ttdoc">Pointer to SC0 register structure.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l10646">Nano1X2Series.h:10646</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n_html_gae3d9f52a1a315303ad04f0576bd42a25"><div class="ttname"><a href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#gae3d9f52a1a315303ad04f0576bd42a25">SYS</a></div><div class="ttdeci">#define SYS</div><div class="ttdoc">Pointer to SYS register structure.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l10650">Nano1X2Series.h:10650</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_ga44414b8c1a7255a01135a0e19d4509cc"><div class="ttname"><a href="../../da/d40/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga44414b8c1a7255a01135a0e19d4509cc">SCUART_CHAR_LEN_8</a></div><div class="ttdeci">#define SCUART_CHAR_LEN_8</div><div class="ttdef"><b>Definition:</b> <a href="../../dc/d0b/scuart_8h_source.html#l00035">scuart.h:35</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_ga4ba056464dc172c46a8c0def775d099c"><div class="ttname"><a href="../../da/d40/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga4ba056464dc172c46a8c0def775d099c">SCUART_PARITY_NONE</a></div><div class="ttdeci">#define SCUART_PARITY_NONE</div><div class="ttdef"><b>Definition:</b> <a href="../../dc/d0b/scuart_8h_source.html#l00037">scuart.h:37</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga0023f5e961b902ed650fec7051b09f2b"><div class="ttname"><a href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga0023f5e961b902ed650fec7051b09f2b">SCUART_SetTimeoutCnt</a></div><div class="ttdeci">void SCUART_SetTimeoutCnt(SC_T *sc, uint32_t u32TOC)</div><div class="ttdoc">This function use to set receive timeout count.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d4a/scuart_8c_source.html#l00184">scuart.c:184</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga156dbf7f35a69e25f2115822fccfa717"><div class="ttname"><a href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga156dbf7f35a69e25f2115822fccfa717">SCUART_GET_TX_FULL</a></div><div class="ttdeci">#define SCUART_GET_TX_FULL(sc)</div><div class="ttdoc">Get TX FIFO full flag status from register.</div><div class="ttdef"><b>Definition:</b> <a href="../../dc/d0b/scuart_8h_source.html#l00080">scuart.h:80</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga1b2ed639a9d9b3389a0252a3e0185ace"><div class="ttname"><a href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga1b2ed639a9d9b3389a0252a3e0185ace">SCUART_Read</a></div><div class="ttdeci">uint32_t SCUART_Read(SC_T *sc, uint8_t *pu8RxBuf, uint32_t u32ReadBytes)</div><div class="ttdoc">The function is used to read Rx data from RX FIFO.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d4a/scuart_8c_source.html#l00113">scuart.c:113</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga1ca8f849e3eaeb01f952b6cb1dbe1541"><div class="ttname"><a href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga1ca8f849e3eaeb01f952b6cb1dbe1541">SCUART_GET_RX_EMPTY</a></div><div class="ttdeci">#define SCUART_GET_RX_EMPTY(sc)</div><div class="ttdoc">Get RX FIFO empty flag status from register.</div><div class="ttdef"><b>Definition:</b> <a href="../../dc/d0b/scuart_8h_source.html#l00130">scuart.h:130</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga275c62ae8ce1ccbd4be6dd52a7ee6144"><div class="ttname"><a href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga275c62ae8ce1ccbd4be6dd52a7ee6144">SCUART_Write</a></div><div class="ttdeci">void SCUART_Write(SC_T *sc, uint8_t *pu8TxBuf, uint32_t u32WriteBytes)</div><div class="ttdoc">This function is to write data into transmit FIFO to send data out.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d4a/scuart_8c_source.html#l00198">scuart.c:198</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga88bae72589f1b3169b6f44141624547a"><div class="ttname"><a href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga88bae72589f1b3169b6f44141624547a">SCUART_READ</a></div><div class="ttdeci">#define SCUART_READ(sc)</div><div class="ttdoc">Read Rx data register.</div><div class="ttdef"><b>Definition:</b> <a href="../../dc/d0b/scuart_8h_source.html#l00120">scuart.h:120</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga99195e1a1d2f0b780a9ec769c5a6825a"><div class="ttname"><a href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga99195e1a1d2f0b780a9ec769c5a6825a">SCUART_SetLineConfig</a></div><div class="ttdeci">uint32_t SCUART_SetLineConfig(SC_T *sc, uint32_t u32Baudrate, uint32_t u32DataWidth, uint32_t u32Parity, uint32_t u32StopBits)</div><div class="ttdoc">This function use to config smartcard UART mode line setting.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d4a/scuart_8c_source.html#l00153">scuart.c:153</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gac5ef61f705cf44b678207aaecb2d8b35"><div class="ttname"><a href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gac5ef61f705cf44b678207aaecb2d8b35">SCUART_Open</a></div><div class="ttdeci">uint32_t SCUART_Open(SC_T *sc, uint32_t u32baudrate)</div><div class="ttdoc">This function use to enable smartcard module UART mode and set baudrate.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d4a/scuart_8c_source.html#l00091">scuart.c:91</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gaee19cdbe4e45656a56c250577c1594c7"><div class="ttname"><a href="../../df/dae/group___n_a_n_o1_x2___s_c_u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaee19cdbe4e45656a56c250577c1594c7">SCUART_Close</a></div><div class="ttdeci">void SCUART_Close(SC_T *sc)</div><div class="ttdoc">The function is used to disable smartcard interface UART mode.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d4a/scuart_8c_source.html#l00032">scuart.c:32</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___s_y_s___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_gab6f82bf5cf18e6161e3d937d3363d76f"><div class="ttname"><a href="../../dc/d4e/group___n_a_n_o1_x2___s_y_s___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gab6f82bf5cf18e6161e3d937d3363d76f">SYS_IRCTRIMCTL_TRIM_16M</a></div><div class="ttdeci">#define SYS_IRCTRIMCTL_TRIM_16M</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d87/sys_8h_source.html#l00078">sys.h:78</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2__legacy___constants_html_ga35c7fa9d62529991f3e3b737945db3a4"><div class="ttname"><a href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga35c7fa9d62529991f3e3b737945db3a4">SC_T::UACTL</a></div><div class="ttdeci">__IO uint32_t UACTL</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l08127">Nano1X2Series.h:8127</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2__legacy___constants_html_ga45c091e2ae29b2e35d20f989adc427a2"><div class="ttname"><a href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga45c091e2ae29b2e35d20f989adc427a2">SC_T::ETUCR</a></div><div class="ttdeci">__IO uint32_t ETUCR</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l07796">Nano1X2Series.h:7796</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2__legacy___constants_html_ga657b6619f178ac1a923485d599c1b0f7"><div class="ttname"><a href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga657b6619f178ac1a923485d599c1b0f7">SC_T::CTL</a></div><div class="ttdeci">__IO uint32_t CTL</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l07658">Nano1X2Series.h:7658</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2__legacy___constants_html_ga90acfb650851f2b72a3dca73041b5df4"><div class="ttname"><a href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga90acfb650851f2b72a3dca73041b5df4">SC_T::RFTMR</a></div><div class="ttdeci">__IO uint32_t RFTMR</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l07776">Nano1X2Series.h:7776</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2__legacy___constants_html_gadfe33df8456b56de687076679cd493f3"><div class="ttname"><a href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gadfe33df8456b56de687076679cd493f3">SC_T::THR</a></div><div class="ttdeci">__O uint32_t THR</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l07570">Nano1X2Series.h:7570</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2__legacy___constants_html_gae664041daf8c26402757b67aaa5677e2"><div class="ttname"><a href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gae664041daf8c26402757b67aaa5677e2">SC_T::IER</a></div><div class="ttdeci">__IO uint32_t IER</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l07852">Nano1X2Series.h:7852</a></div></div>
<div class="ttc" id="astruct_s_c___t_html"><div class="ttname"><a href="../../d6/d6b/struct_s_c___t.html">SC_T</a></div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l07543">Nano1X2Series.h:7544</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8h_html_a37c1644396b5996e92902bbf2dfc3ec5"><div class="ttname"><a href="../../d9/dd8/system___nano1_x2_series_8h.html#a37c1644396b5996e92902bbf2dfc3ec5">__HXT</a></div><div class="ttdeci">#define __HXT</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/dd8/system___nano1_x2_series_8h_source.html#l00026">system_Nano1X2Series.h:26</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8h_html_aa3cd3e43291e81e795d642b79b6088e6"><div class="ttname"><a href="../../d9/dd8/system___nano1_x2_series_8h.html#aa3cd3e43291e81e795d642b79b6088e6">SystemCoreClock</a></div><div class="ttdeci">uint32_t SystemCoreClock</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d7e/system___nano1_x2_series_8c_source.html#l00020">system_Nano1X2Series.c:20</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8h_html_aae5c5ec4722a291e1271743d45414223"><div class="ttname"><a href="../../d9/dd8/system___nano1_x2_series_8h.html#aae5c5ec4722a291e1271743d45414223">__HIRC16M</a></div><div class="ttdeci">#define __HIRC16M</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/dd8/system___nano1_x2_series_8h_source.html#l00029">system_Nano1X2Series.h:29</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8h_html_ad145c32431f633b887d84ef0c78f42f3"><div class="ttname"><a href="../../d9/dd8/system___nano1_x2_series_8h.html#ad145c32431f633b887d84ef0c78f42f3">__HIRC12M</a></div><div class="ttdeci">#define __HIRC12M</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/dd8/system___nano1_x2_series_8h_source.html#l00028">system_Nano1X2Series.h:28</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Oct 18 2024 12:20:31 for NANO102/112 BSP by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
